summaryrefslogtreecommitdiff
path: root/archiso
diff options
context:
space:
mode:
authorAndré Fabian Silva Delgado <andre@pc-01.localdomain>2012-05-04 15:33:55 -0300
committerAndré Fabian Silva Delgado <andre@pc-01.localdomain>2012-05-04 15:33:55 -0300
commit6bdcc59f94ecd2fd84facda953f92e1d2a5cf727 (patch)
treee3348a3a05ae33a3d6040f2f7a38a260cdc4a065 /archiso
parent64a660adb9a1ad658874759c186e0e9cbf138e63 (diff)
updating all files
Diffstat (limited to 'archiso')
-rw-r--r--archiso/Makefile44
-rw-r--r--archiso/archiso_pxe_nbd6
-rw-r--r--archiso/archiso_shutdown40
-rw-r--r--archiso/hooks/archiso210
-rw-r--r--archiso/hooks/archiso_loop_mnt33
-rw-r--r--archiso/hooks/archiso_pxe_common42
-rw-r--r--archiso/hooks/archiso_pxe_http61
-rw-r--r--archiso/hooks/archiso_pxe_nbd73
-rw-r--r--archiso/hooks/archiso_pxe_nfs26
-rw-r--r--archiso/hooks/archiso_shutdown23
-rw-r--r--archiso/install/archiso39
-rw-r--r--archiso/install/archiso_kms14
-rw-r--r--archiso/install/archiso_loop_mnt15
-rw-r--r--archiso/install/archiso_pxe_common30
-rw-r--r--archiso/install/archiso_pxe_http15
-rw-r--r--archiso/install/archiso_pxe_nbd22
-rw-r--r--archiso/install/archiso_pxe_nfs16
-rw-r--r--archiso/install/archiso_shutdown18
-rwxr-xr-xarchiso/mkarchiso257
-rwxr-xr-xarchiso/testiso10
20 files changed, 673 insertions, 321 deletions
diff --git a/archiso/Makefile b/archiso/Makefile
index 60632e2..28868bf 100644
--- a/archiso/Makefile
+++ b/archiso/Makefile
@@ -10,12 +10,23 @@ install-program:
install-hooks:
# hooks/install are needed by mkinitcpio
- install -D -m 644 hooks/archiso $(DESTDIR)/lib/initcpio/hooks/archiso
- install -D -m 644 install/archiso $(DESTDIR)/lib/initcpio/install/archiso
- install -D -m 644 hooks/archiso_pxe_nbd $(DESTDIR)/lib/initcpio/hooks/archiso_pxe_nbd
- install -D -m 644 install/archiso_pxe_nbd $(DESTDIR)/lib/initcpio/install/archiso_pxe_nbd
- install -D -m 644 hooks/archiso_loop_mnt $(DESTDIR)/lib/initcpio/hooks/archiso_loop_mnt
- install -D -m 644 install/archiso_loop_mnt $(DESTDIR)/lib/initcpio/install/archiso_loop_mnt
+ install -D -m 644 hooks/archiso $(DESTDIR)/usr/lib/initcpio/hooks/archiso
+ install -D -m 644 install/archiso $(DESTDIR)/usr/lib/initcpio/install/archiso
+ install -D -m 755 archiso_shutdown $(DESTDIR)/usr/lib/initcpio/archiso_shutdown
+ install -D -m 644 hooks/archiso_shutdown $(DESTDIR)/usr/lib/initcpio/hooks/archiso_shutdown
+ install -D -m 644 install/archiso_shutdown $(DESTDIR)/usr/lib/initcpio/install/archiso_shutdown
+ install -D -m 644 archiso_pxe_nbd $(DESTDIR)/usr/lib/initcpio/archiso_pxe_nbd
+ install -D -m 644 hooks/archiso_pxe_common $(DESTDIR)/usr/lib/initcpio/hooks/archiso_pxe_common
+ install -D -m 644 install/archiso_pxe_common $(DESTDIR)/usr/lib/initcpio/install/archiso_pxe_common
+ install -D -m 644 hooks/archiso_pxe_nbd $(DESTDIR)/usr/lib/initcpio/hooks/archiso_pxe_nbd
+ install -D -m 644 install/archiso_pxe_nbd $(DESTDIR)/usr/lib/initcpio/install/archiso_pxe_nbd
+ install -D -m 644 hooks/archiso_pxe_http $(DESTDIR)/usr/lib/initcpio/hooks/archiso_pxe_http
+ install -D -m 644 install/archiso_pxe_http $(DESTDIR)/usr/lib/initcpio/install/archiso_pxe_http
+ install -D -m 644 hooks/archiso_pxe_nfs $(DESTDIR)/usr/lib/initcpio/hooks/archiso_pxe_nfs
+ install -D -m 644 install/archiso_pxe_nfs $(DESTDIR)/usr/lib/initcpio/install/archiso_pxe_nfs
+ install -D -m 644 hooks/archiso_loop_mnt $(DESTDIR)/usr/lib/initcpio/hooks/archiso_loop_mnt
+ install -D -m 644 install/archiso_loop_mnt $(DESTDIR)/usr/lib/initcpio/install/archiso_loop_mnt
+ install -D -m 644 install/archiso_kms $(DESTDIR)/usr/lib/initcpio/install/archiso_kms
install-examples:
# install examples
@@ -29,10 +40,23 @@ install-doc:
uninstall:
rm -f $(DESTDIR)/usr/sbin/mkarchiso
rm -f $(DESTDIR)/usr/bin/testiso
- rm -f $(DESTDIR)/lib/initcpio/hooks/archiso
- rm -f $(DESTDIR)/lib/initcpio/install/archiso
- rm -f $(DESTDIR)/lib/initcpio/hooks/archiso_pxe_nbd
- rm -f $(DESTDIR)/lib/initcpio/install/archiso_pxe_nbd
+ rm -f $(DESTDIR)/usr/lib/initcpio/hooks/archiso
+ rm -f $(DESTDIR)/usr/lib/initcpio/install/archiso
+ rm -f $(DESTDIR)/usr/lib/initcpio/archiso_shutdown
+ rm -f $(DESTDIR)/usr/lib/initcpio/hooks/archiso_shutdown
+ rm -f $(DESTDIR)/usr/lib/initcpio/install/archiso_shutdown
+ rm -f $(DESTDIR)/usr/lib/initcpio/archiso_pxe_nbd
+ rm -f $(DESTDIR)/usr/lib/initcpio/hooks/archiso_pxe_common
+ rm -f $(DESTDIR)/usr/lib/initcpio/install/archiso_pxe_common
+ rm -f $(DESTDIR)/usr/lib/initcpio/hooks/archiso_pxe_nbd
+ rm -f $(DESTDIR)/usr/lib/initcpio/install/archiso_pxe_nbd
+ rm -f $(DESTDIR)/usr/lib/initcpio/hooks/archiso_pxe_http
+ rm -f $(DESTDIR)/usr/lib/initcpio/install/archiso_pxe_http
+ rm -f $(DESTDIR)/usr/lib/initcpio/hooks/archiso_pxe_nfs
+ rm -f $(DESTDIR)/usr/lib/initcpio/install/archiso_pxe_nfs
+ rm -f $(DESTDIR)/usr/lib/initcpio/hooks/archiso_loop_mnt
+ rm -f $(DESTDIR)/usr/lib/initcpio/install/archiso_loop_mnt
+ rm -f $(DESTDIR)/usr/lib/initcpio/install/archiso_kms
rm -rf $(DESTDIR)/usr/share/archiso/
.PHONY: install install-program install-hooks install-examples install-doc uninstall
diff --git a/archiso/archiso_pxe_nbd b/archiso/archiso_pxe_nbd
new file mode 100644
index 0000000..e6b9872
--- /dev/null
+++ b/archiso/archiso_pxe_nbd
@@ -0,0 +1,6 @@
+omit_kill_nbd_client() {
+ add_omit_pids $(< /run/archiso/nbd_client.pid)
+}
+
+add_hook shutdown_prekillall omit_kill_nbd_client
+add_hook single_prekillall omit_kill_nbd_client
diff --git a/archiso/archiso_shutdown b/archiso/archiso_shutdown
new file mode 100644
index 0000000..85cce59
--- /dev/null
+++ b/archiso/archiso_shutdown
@@ -0,0 +1,40 @@
+#!/bin/ash
+
+# /oldroot depends on things inside /oldroot/run/archiso...
+mkdir /oldrun
+mount -n --move /oldroot/run /oldrun
+
+# Unmount all mounts now.
+umount $(mount | awk '$3 ~/^\/oldroot/ {print $3}' | sort -r)
+
+# Remove all dm-snapshot devices.
+dmsetup remove_all
+
+# Remove all loopback devices.
+for _lup in $(grep ^/dev/loop /oldrun/archiso/used_block_devices | tac); do
+ if ! losetup -d ${_lup} 2> /dev/null; then
+ umount -d ${_lup}
+ fi
+done
+
+# Unmount the space used to store *.cow.
+umount /oldrun/archiso/cowspace
+
+# Unmount boot device if needed (no copytoram=y used)
+if [[ ! -d /oldrun/archiso/copytoram ]]; then
+ if [[ -d /oldrun/archiso/img_dev ]]; then
+ umount /oldrun/archiso/img_dev
+ else
+ umount /oldrun/archiso/bootmnt
+ fi
+ if [[ -f /oldrun/archiso/nbd_client.pid ]]; then
+ nbd-client -d /dev/nbd0
+ fi
+fi
+
+# reboot / poweroff / halt, depending on the argument passed by init
+# if something invalid is passed, we halt
+case "$1" in
+ reboot|poweroff|halt) "$1" -f ;;
+ *) halt -f;;
+esac
diff --git a/archiso/hooks/archiso b/archiso/hooks/archiso
index c973ffc..9445498 100644
--- a/archiso/hooks/archiso
+++ b/archiso/hooks/archiso
@@ -1,92 +1,100 @@
-# Initialize loopback device logic (we using on-demand mode)
-# args: none
-_init_loop_dev() {
- modprobe loop
- loop_dev_count=99
- loop_dev_range=$(cat /sys/block/loop0/range)
- loop_dev_minor=$((loop_dev_count*loop_dev_range))
-}
-
-# Call this function before _make_loop_dev() each time.
-# args: none
-_next_loop_dev() {
- loop_dev_count=$((loop_dev_count+1))
- loop_dev_minor=$((loop_dev_count*loop_dev_range))
-}
-
-# Setup a loopback device for image passed as argument and echo the path to loopback device used.
-# args: /path/to/image_file
-_make_loop_dev() {
- local img="${1}"
- mknod /dev/loop${loop_dev_count} b 7 ${loop_dev_minor} &> /dev/null
- losetup /dev/loop${loop_dev_count} "${img}" &> /dev/null
- echo /dev/loop${loop_dev_count}
-}
-
-# args: source, mountpoint
+# args: source, newroot, mountpoint
_mnt_fs() {
local img="${1}"
- local mnt="${2}"
+ local newroot="${2}"
+ local mnt="${3}"
local img_fullname="${img##*/}";
local img_name="${img_fullname%%.*}"
local dm_snap_name="${dm_snap_prefix}_${img_name}"
- local ro_dev ro_dev_size ro_dev_fs_type rw_dev
+ local ro_dev ro_dev_size rw_dev
- mkdir -p "${mnt}"
-
- _next_loop_dev
- ro_dev=$(_make_loop_dev "${img}")
+ ro_dev=$(losetup --find --show --read-only "${img}")
+ echo ${ro_dev} >> /run/archiso/used_block_devices
ro_dev_size=$(blockdev --getsz ${ro_dev})
- ro_dev_fs_type=$(blkid -o value -s TYPE -p ${ro_dev} 2> /dev/null)
- dd of="/cowspace/${img_name}.cow" count=0 seek=${ro_dev_size} &> /dev/null
- _next_loop_dev
- rw_dev=$(_make_loop_dev "/cowspace/${img_name}.cow")
+ if [[ "${cow_persistent}" == "P" ]]; then
+ if [[ -f "/run/archiso/cowspace/${cow_directory}/${img_name}.cow" ]]; then
+ msg ":: Found '/run/archiso/cowspace/${cow_directory}/${img_name}.cow', using as persistent."
+ else
+ msg ":: Creating '/run/archiso/cowspace/${cow_directory}/${img_name}.cow' as persistent."
+ dd of="/run/archiso/cowspace/${cow_directory}/${img_name}.cow" count=0 seek=${ro_dev_size} &> /dev/null
+ fi
+ else
+ if [[ -f "/run/archiso/cowspace/${cow_directory}/${img_name}.cow" ]]; then
+ msg ":: Found '/run/archiso/cowspace/${cow_directory}/${img_name}.cow' but non-persistent requested, removing."
+ rm -f "/run/archiso/cowspace/${cow_directory}/${img_name}.cow"
+ fi
+ msg ":: Creating '/run/archiso/cowspace/${cow_directory}/${img_name}.cow' as non-persistent."
+ dd of="/run/archiso/cowspace/${cow_directory}/${img_name}.cow" count=0 seek=${ro_dev_size} &> /dev/null
+ fi
+
+ rw_dev=$(losetup --find --show "/run/archiso/cowspace/${cow_directory}/${img_name}.cow")
+ echo ${rw_dev} >> /run/archiso/used_block_devices
- echo "0 ${ro_dev_size} snapshot ${ro_dev} ${rw_dev} N 8" | dmsetup create ${dm_snap_name}
+ echo "0 ${ro_dev_size} snapshot ${ro_dev} ${rw_dev} ${cow_persistent} 8" | dmsetup create ${dm_snap_name}
- msg ":: Mounting '/dev/mapper/${dm_snap_name}' (${ro_dev_fs_type}) to '${mnt}'"
- if ! mount -t "${ro_dev_fs_type}" "/dev/mapper/${dm_snap_name}" "${mnt}" ; then
- echo "ERROR: while mounting '/dev/mapper/${dm_snap_name}' to '${mnt}'"
- launch_interactive_shell
- fi
+ _mnt_dev "/dev/mapper/${dm_snap_name}" "${newroot}${mnt}" "-w"
+ echo $(readlink -f /dev/mapper/${dm_snap_name}) >> /run/archiso/used_block_devices
+ echo "/dev/mapper/${dm_snap_name} ${mnt} auto defaults 0 0" >> ${newroot}/etc/fstab
}
# args: /path/to/image_file, mountpoint
_mnt_sfs() {
local img="${1}"
local mnt="${2}"
- local img_fullname="${img##*/}";
-
- mkdir -p "${mnt}"
+ local img_fullname="${img##*/}"
+ local sfs_dev
if [[ "${copytoram}" == "y" ]]; then
msg -n ":: Copying squashfs image to RAM..."
- if ! cp "${img}" "/copytoram/${img_fullname}" ; then
- echo "ERROR: while copy '${img}' to '/copytoram/${img_fullname}'"
+ if ! cp "${img}" "/run/archiso/copytoram/${img_fullname}" ; then
+ echo "ERROR: while copy '${img}' to '/run/archiso/copytoram/${img_fullname}'"
launch_interactive_shell
fi
- img="/copytoram/${img_fullname}"
+ img="/run/archiso/copytoram/${img_fullname}"
msg "done."
fi
- _next_loop_dev
- msg ":: Mounting '${img}' (SquashFS) to '${mnt}'"
- if ! mount -r -t squashfs $(_make_loop_dev "${img}") "${mnt}" &> /dev/null ; then
- echo "ERROR: while mounting '${img}' to '${mnt}'"
+ sfs_dev=$(losetup --find --show --read-only "${img}")
+ echo ${sfs_dev} >> /run/archiso/used_block_devices
+ _mnt_dev "${sfs_dev}" "${mnt}" "-r"
+}
+
+# args: device, mountpoint, flags
+_mnt_dev() {
+ local dev="${1}"
+ local mnt="${2}"
+ local flg="${3}"
+
+ mkdir -p "${mnt}"
+
+ msg ":: Mounting '${dev}' to '${mnt}'"
+
+ while ! poll_device "${dev}" 30; do
+ echo "ERROR: '${dev}' device did not show up after 30 seconds..."
+ echo " Falling back to interactive prompt"
+ echo " You can try to fix the problem manually, log out when you are finished"
+ launch_interactive_shell
+ done
+
+ if mount "${flg}" "${dev}" "${mnt}"; then
+ msg ":: Device '${dev}' mounted successfully."
+ else
+ echo "ERROR; Failed to mount '${dev}'"
+ echo " Falling back to interactive prompt"
+ echo " You can try to fix the problem manually, log out when you are finished"
launch_interactive_shell
fi
}
_verify_checksum() {
local _status
- cd "/bootmnt/${archisobasedir}"
- md5sum -c checksum.md5 > /checksum.log 2>&1
+ cd "/run/archiso/bootmnt/${archisobasedir}"
+ md5sum -c checksum.${arch}.md5 > /tmp/checksum.${arch}.log 2>&1
_status=$?
cd "${OLDPWD}"
return ${_status}
}
-
run_hook() {
[[ -z "${arch}" ]] && arch="$(uname -m)"
[[ -z "${cowspace_size}" ]] && cowspace_size="75%"
@@ -94,11 +102,24 @@ run_hook() {
[[ -z "${archisobasedir}" ]] && archisobasedir="arch"
[[ -z "${dm_snap_prefix}" ]] && dm_snap_prefix="arch"
[[ -z "${archisodevice}" ]] && archisodevice="/dev/disk/by-label/${archisolabel}"
+
if [[ -z "${aitab}" ]]; then
- aitab="/bootmnt/${archisobasedir}/aitab"
+ aitab="/run/archiso/bootmnt/${archisobasedir}/aitab"
else
- aitab="/bootmnt/${aitab}"
+ aitab="/run/archiso/bootmnt/${archisobasedir}/${aitab}"
fi
+
+ if [[ -n "${cow_label}" ]]; then
+ cow_device="/dev/disk/by-label/${cow_label}"
+ [[ -z "${cow_persistent}" ]] && cow_persistent="P"
+ elif [[ -n "${cow_device}" ]]; then
+ [[ -z "${cow_persistent}" ]] && cow_persistent="P"
+ else
+ cow_persistent="N"
+ fi
+
+ [[ -z "${cow_directory}" ]] && cow_directory="persistent_${archisolabel}/${arch}"
+
# set mount handler for archiso
mount_handler="archiso_mount_handler"
}
@@ -108,90 +129,69 @@ run_hook() {
# args: /path/to/newroot
archiso_mount_handler() {
local newroot="${1}"
- local fstype fserror
-
- _init_loop_dev
-
- msg ":: Waiting for boot device..."
- while ! poll_device "${archisodevice}" 30; do
- echo "ERROR: boot device didn't show up after 30 seconds..."
- echo " Falling back to interactive prompt"
- echo " You can try to fix the problem manually, log out when you are finished"
- launch_interactive_shell
- done
- fstype=$(blkid -o value -s TYPE -p "${archisodevice}" 2> /dev/null)
- if [[ -n "${fstype}" ]]; then
- if mount -r -t "${fstype}" "${archisodevice}" /bootmnt; then
- if [[ -f "${aitab}" ]]; then
- msg ":: Mounted archiso volume successfully."
- fserror=0
- else
- echo "ERROR: Mounting was successful, but the '${aitab}' file does not exist."
- fserror=1
- fi
- else
- echo "ERROR; Failed to mount '${archisodevice}' (FS is ${fstype})"
- fserror=1
+ if ! mountpoint -q "/run/archiso/bootmnt"; then
+ _mnt_dev "${archisodevice}" "/run/archiso/bootmnt" "-r"
+ if [[ "${copytoram}" != "y" ]]; then
+ echo $(readlink -f ${archisodevice}) >> /run/archiso/used_block_devices
fi
- else
- echo "ERROR: '${archisodevice}' found, but the filesystem type is unknown."
- fserror=1
fi
- if [[ ${fserror} -eq 1 ]]; then
+
+ if [[ ! -f "${aitab}" ]]; then
+ echo "ERROR: '${aitab}' file does not exist."
echo " Falling back to interactive prompt"
echo " You can try to fix the problem manually, log out when you are finished"
launch_interactive_shell
fi
if [[ "${checksum}" == "y" ]]; then
- if [[ -f "/bootmnt/${archisobasedir}/checksum.md5" ]]; then
+ if [[ -f "/run/archiso/bootmnt/${archisobasedir}/checksum.${arch}.md5" ]]; then
msg -n ":: Self-test requested, please wait..."
if _verify_checksum; then
msg "done. Checksum is OK, continue booting."
else
echo "ERROR: one or more files are corrupted"
- echo "see /checksum.log for details"
+ echo "see /tmp/checksum.${arch}.log for details"
launch_interactive_shell
fi
else
- echo "ERROR: checksum=y option specified but checksum.md5 not found"
+ echo "ERROR: checksum=y option specified but checksum.${arch}.md5 not found"
launch_interactive_shell
fi
fi
if [[ "${copytoram}" == "y" ]]; then
- msg -n ":: Mounting /copytoram (tmpfs) filesystem, size=${copytoram_size}..."
- mount -t tmpfs -o "size=${copytoram_size}",mode=0755 copytoram /copytoram
- msg "done."
+ msg ":: Mounting /run/archiso/copytoram (tmpfs) filesystem, size=${copytoram_size}"
+ mkdir -p /run/archiso/copytoram
+ mount -t tmpfs -o "size=${copytoram_size}",mode=0755 copytoram /run/archiso/copytoram
fi
- msg -n ":: Mounting /cowspace (tmpfs) filesystem, size=${cowspace_size}..."
- mount -t tmpfs -o "size=${cowspace_size}",mode=0755 cowspace /cowspace
- msg "done."
+ if [[ -n "${cow_device}" ]]; then
+ _mnt_dev "${cow_device}" "/run/archiso/cowspace" "-r"
+ echo $(readlink -f ${cow_device}) >> /run/archiso/used_block_devices
+ mount -o remount,rw "/run/archiso/cowspace"
+ else
+ msg ":: Mounting /run/archiso/cowspace (tmpfs) filesystem, size=${cowspace_size}..."
+ mkdir -p /run/archiso/cowspace
+ mount -t tmpfs -o "size=${cowspace_size}",mode=0755 cowspace /run/archiso/cowspace
+ fi
+ mkdir -p "/run/archiso/cowspace/${cow_directory}"
local aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size
while read aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size; do
[[ "${aitab_img#\#}" != "${aitab_img}" ]] && continue
[[ "${aitab_arch}" != "any" && "${aitab_arch}" != "${arch}" ]] && continue
if [[ "${aitab_fs_type}" != "none" ]]; then
- if [[ "${aitab_sfs_comp}" != "none" ]]; then
- _mnt_sfs "/bootmnt/${archisobasedir}/${aitab_arch}/${aitab_img}.fs.sfs" "/sfs/${aitab_img}"
- _mnt_fs "/sfs/${aitab_img}/${aitab_img}.fs" "${newroot}${aitab_mnt}"
- else
- _mnt_fs "/bootmnt/${archisobasedir}/${aitab_arch}/${aitab_img}.fs" "${newroot}${aitab_mnt}"
- fi
+ _mnt_sfs "/run/archiso/bootmnt/${archisobasedir}/${aitab_arch}/${aitab_img}.fs.sfs" "/run/archiso/sfs/${aitab_img}"
+ _mnt_fs "/run/archiso/sfs/${aitab_img}/${aitab_img}.fs" "${newroot}" "${aitab_mnt}"
else
- _mnt_sfs "/bootmnt/${archisobasedir}/${aitab_arch}/${aitab_img}.sfs" "${newroot}${aitab_mnt}"
+ _mnt_sfs "/run/archiso/bootmnt/${archisobasedir}/${aitab_arch}/${aitab_img}.sfs" "${newroot}${aitab_mnt}"
fi
done < "${aitab}"
if [[ "${copytoram}" == "y" ]]; then
- umount /bootmnt
- else
- mkdir "${newroot}/bootmnt"
- mount --bind /bootmnt "${newroot}/bootmnt"
+ umount /run/archiso/bootmnt
fi
}
diff --git a/archiso/hooks/archiso_loop_mnt b/archiso/hooks/archiso_loop_mnt
index 13f8743..a02cfac 100644
--- a/archiso/hooks/archiso_loop_mnt
+++ b/archiso/hooks/archiso_loop_mnt
@@ -1,7 +1,8 @@
# vim: set ft=sh:
run_hook () {
- if [ -n "${img_dev}" ] && [ -n "${img_loop}" ]; then
+ [[ -n "${img_label}" ]] && img_dev="/dev/disk/by-label/${img_label}"
+ if [[ -n "${img_dev}" && -n "${img_loop}" ]]; then
mount_handler="archiso_loop_mount_handler"
fi
}
@@ -9,29 +10,23 @@ run_hook () {
archiso_loop_mount_handler () {
newroot="${1}"
- msg ":: Waiting for boot device..."
- while ! poll_device ${img_dev} 30; do
- echo "ERROR: boot device didn't show up after 30 seconds..."
- echo " Falling back to interactive prompt"
- echo " You can try to fix the problem manually, log out when you are finished"
- launch_interactive_shell
- done
+ local _dev_loop
+
+ msg ":: Setup a loop device from ${img_loop} located at device ${img_dev}"
+ _mnt_dev "${img_dev}" "/run/archiso/img_dev" "-r"
+ if [[ "${copytoram}" != "y" ]]; then
+ echo $(readlink -f ${img_dev}) >> /run/archiso/used_block_devices
+ fi
- msg "::: Setup a loop device from ${img_loop} located at device ${img_dev}"
- FSTYPE=$(blkid -o value -s TYPE -p ${img_dev} 2> /dev/null)
- if [ -n "${FSTYPE}" ]; then
- if mount -r -t "${FSTYPE}" ${img_dev} /img_dev > /dev/null 2>&1; then
- _dev_loop=$(losetup -f)
- losetup ${_dev_loop} /img_dev/${img_loop}
- fi
+ if ! _dev_loop=$(losetup --find --show --read-only "/run/archiso/img_dev/${img_loop}"); then
+ echo "ERROR: Setting loopback device for file '/run/archiso/img_dev/${img_loop}'"
+ launch_interactive_shell
fi
archiso_mount_handler ${newroot}
- if [ "${copytoram}" = "y" ]; then
- msg "::: Deataching loop device ${_dev_loop}"
+ if [[ "${copytoram}" == "y" ]]; then
losetup -d ${_dev_loop}
- msg "::: Unmounting ${img_dev}"
- umount ${img_dev}
+ umount /run/archiso/img_dev
fi
}
diff --git a/archiso/hooks/archiso_pxe_common b/archiso/hooks/archiso_pxe_common
new file mode 100644
index 0000000..febb503
--- /dev/null
+++ b/archiso/hooks/archiso_pxe_common
@@ -0,0 +1,42 @@
+# vim: set ft=sh:
+
+run_hook () {
+ local i net_mac bootif_mac bootif_dev
+ # These variables will be parsed from /tmp/net-*.conf generated by ipconfig
+ local DEVICE
+ local IPV4ADDR IPV4BROADCAST IPV4NETMASK IPV4GATEWAY IPV4DNS0 IPV4DNS1
+ local HOSTNAME DNSDOMAIN NISDOMAIN ROOTSERVER ROOTPATH
+ local filename
+ # /tmp/net-*.conf
+
+ if [[ -n "${ip}" ]]; then
+ if [[ -n "${BOOTIF}" ]]; then
+ bootif_mac=${BOOTIF#01-}
+ bootif_mac=${bootif_mac//-/:}
+ for i in /sys/class/net/*/address; do
+ read net_mac < ${i}
+ if [[ "${bootif_mac}" == "${net_mac}" ]]; then
+ bootif_dev=${i#/sys/class/net/}
+ bootif_dev=${bootif_dev%/address}
+ break
+ fi
+ done
+ ip="${ip}::${bootif_dev}"
+ fi
+
+ # setup network and save some values
+ ipconfig "ip=${ip}"
+
+ . /tmp/net-*.conf
+
+ pxeserver=${ROOTSERVER}
+
+ # setup DNS resolver
+ if [[ "${IPV4DNS0}" != "0.0.0.0" ]]; then
+ echo "nameserver ${IPV4DNS0}" > /etc/resolv.conf
+ fi
+ if [[ "${IPV4DNS1}" != "0.0.0.0" ]]; then
+ echo "nameserver ${IPV4DNS1}" >> /etc/resolv.conf
+ fi
+ fi
+}
diff --git a/archiso/hooks/archiso_pxe_http b/archiso/hooks/archiso_pxe_http
new file mode 100644
index 0000000..ae56210
--- /dev/null
+++ b/archiso/hooks/archiso_pxe_http
@@ -0,0 +1,61 @@
+# vim: set ft=sh:
+
+run_hook() {
+ if [[ -n "${ip}" && -n "${archiso_http_srv}" ]]; then
+
+ archiso_http_srv=$(eval echo ${archiso_http_srv})
+ [[ -z "${archiso_http_spc}" ]] && archiso_http_spc="75%"
+
+ mount_handler="archiso_pxe_http_mount_handler"
+ fi
+}
+
+# Fetch a file with CURL
+#
+# $1 URL
+# $2 Destination directory inside httpspace/${archisobasedir}
+_curl_get() {
+ local _url="${1}"
+ local _dst="${2}"
+
+ msg ":: Downloading '${_url}'"
+ if ! curl -f -o "/run/archiso/httpspace/${archisobasedir}${_dst}/${_url##*/}" --create-dirs "${_url}"; then
+ echo "ERROR: Downloading '${_url}'"
+ echo " Falling back to interactive prompt"
+ echo " You can try to fix the problem manually, log out when you are finished"
+ launch_interactive_shell
+ fi
+}
+
+archiso_pxe_http_mount_handler () {
+ newroot="${1}"
+
+ msg ":: Mounting /run/archiso/httpspace (tmpfs) filesystem, size='${archiso_http_spc}'"
+ mkdir -p "/run/archiso/httpspace"
+ mount -t tmpfs -o size="${archiso_http_spc}",mode=0755 httpspace "/run/archiso/httpspace"
+
+ local _aitab_url="${archiso_http_srv}${aitab#/run/archiso/bootmnt/}"
+ local _aitab_file="/run/archiso/httpspace/${aitab#/run/archiso/bootmnt/}"
+
+ _curl_get "${_aitab_url}" "/"
+
+ local aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size
+ while read aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size; do
+ [[ "${aitab_img#\#}" != "${aitab_img}" ]] && continue
+ [[ "${aitab_arch}" != "any" && "${aitab_arch}" != "${arch}" ]] && continue
+ if [[ "${aitab_fs_type}" != "none" ]]; then
+ _curl_get "${archiso_http_srv}${archisobasedir}/${aitab_arch}/${aitab_img}.fs.sfs" "/${aitab_arch}"
+ else
+ _curl_get "${archiso_http_srv}${archisobasedir}/${aitab_arch}/${aitab_img}.sfs" "/${aitab_arch}"
+ fi
+ done < "${_aitab_file}"
+
+ if [[ "${checksum}" == "y" ]]; then
+ _curl_get "${archiso_http_srv}${archisobasedir}/checksum.${arch}.md5" "/"
+ fi
+
+ mkdir -p "/run/archiso/bootmnt"
+ mount -o bind /run/archiso/httpspace /run/archiso/bootmnt
+
+ archiso_mount_handler ${newroot}
+}
diff --git a/archiso/hooks/archiso_pxe_nbd b/archiso/hooks/archiso_pxe_nbd
index 588e033..6147d06 100644
--- a/archiso/hooks/archiso_pxe_nbd
+++ b/archiso/hooks/archiso_pxe_nbd
@@ -1,60 +1,9 @@
# vim: set ft=sh:
-run_hook () {
- local line i address netmask gateway dns0 dns1 rootserver rootpath filename
- : > /ip_opts
-
- if [ -n "${ip}" ]; then
- if [ -n "${BOOTIF}" ]; then
- bootif_mac=${BOOTIF#01-}
- bootif_mac=${bootif_mac//-/:}
- bootif_dev=$(grep -l $bootif_mac /sys/class/net/*/address)
- bootif_dev=${bootif_dev#/sys/class/net/}
- bootif_dev=${bootif_dev%/address}
- ip="$ip::$bootif_dev"
- fi
-
- # setup network and save some values
- ipconfig "ip=${ip}" | while read line; do
- # echo ":: ${line}"
- if [ "${line#"IP-Config:"}" != "${line}" ]; then
- continue
- fi
- line="$(echo ${line} | sed -e 's/ :/:/g;s/: /=/g')"
- for i in ${line}; do
- case "${i}" in
- address=*)
- echo "${i}" >> /ip_opts
- ;;
- netmask=*)
- echo "${i}" >> /ip_opts
- ;;
- gateway=*)
- echo "${i}" >> /ip_opts
- ;;
- dns0=*)
- echo "${i}" >> /ip_opts
- ;;
- dns1=*)
- echo "${i}" >> /ip_opts
- ;;
- rootserver=*)
- echo "${i}" >> /ip_opts
- ;;
- rootpath=*)
- echo "${i}" >> /ip_opts
- ;;
- esac
- done
- done
-
- . /ip_opts
-
- echo "IP-Config: ${address}/${netmask}"
- echo "IP-Config: gw: ${gateway} dns0: ${dns0} dns1: ${dns1}"
-
- nbdserver=${rootserver}
+run_hook() {
+ if [[ -n "${ip}" && -n "${archiso_nbd_srv}" ]]; then
+ archiso_nbd_srv=$(eval echo ${archiso_nbd_srv})
[[ -z "${archiso_nbd_name}" ]] && archiso_nbd_name="archiso"
mount_handler="archiso_pxe_nbd_mount_handler"
@@ -74,21 +23,23 @@ archiso_pxe_nbd_mount_handler () {
launch_interactive_shell
done
- msg "::: Setup NBD from ${nbdserver} at /dev/nbd0"
- if [ "${copytoram}" = "y" ]; then
- nbd-client ${nbdserver} -N ${archiso_nbd_name} /dev/nbd0
+ msg ":: Setup NBD from ${archiso_nbd_srv} at /dev/nbd0"
+ if [[ "${copytoram}" = "y" ]]; then
+ nbd-client ${archiso_nbd_srv} -N ${archiso_nbd_name} /dev/nbd0
else
- nbd-client ${nbdserver} -N ${archiso_nbd_name} /dev/nbd0 -persist
+ nbd-client ${archiso_nbd_srv} -N ${archiso_nbd_name} /dev/nbd0 -persist
fi
archisodevice=/dev/nbd0
archiso_mount_handler ${newroot}
- if [ "${copytoram}" = "y" ]; then
- msg "::: Disconnect NBD from ${nbdserver} at /dev/nbd0"
+ if [[ "${copytoram}" = "y" ]]; then
+ msg ":: Disconnect NBD from ${archiso_nbd_srv} at /dev/nbd0"
nbd-client -d /dev/nbd0
else
- pidof nbd-client > /run/nbd_client.pid
+ mkdir -p /run/archiso
+ pidof nbd-client > /run/archiso/nbd_client.pid
+ cp /archiso_pxe_nbd ${newroot}/etc/rc.d/functions.d/
fi
}
diff --git a/archiso/hooks/archiso_pxe_nfs b/archiso/hooks/archiso_pxe_nfs
new file mode 100644
index 0000000..a053672
--- /dev/null
+++ b/archiso/hooks/archiso_pxe_nfs
@@ -0,0 +1,26 @@
+# vim: set ft=sh:
+
+run_hook() {
+ if [[ -n "${ip}" && -n "${archiso_nfs_srv}" ]]; then
+
+ archiso_nfs_srv=$(eval echo ${archiso_nfs_srv})
+ [[ -n "${archiso_nfs_opt}" ]] && archiso_nfs_opt="-o ${archiso_nfs_opt}"
+
+ mount_handler="archiso_nfs_mount_handler"
+ fi
+}
+
+archiso_nfs_mount_handler() {
+ newroot="${1}"
+ mkdir -p "/run/archiso/bootmnt"
+ msg ":: Mounting '${archiso_nfs_srv}'"
+ # Do not put "${archiso_nfs_opt}" nfsmount fails!
+ if ! nfsmount ${archiso_nfs_opt} "${archiso_nfs_srv}" "/run/archiso/bootmnt"; then
+ echo "ERROR: Mounting '${archiso_nfs_srv}'"
+ echo " Falling back to interactive prompt"
+ echo " You can try to fix the problem manually, log out when you are finished"
+ launch_interactive_shell
+ fi
+
+ archiso_mount_handler ${newroot}
+}
diff --git a/archiso/hooks/archiso_shutdown b/archiso/hooks/archiso_shutdown
new file mode 100644
index 0000000..24e4103
--- /dev/null
+++ b/archiso/hooks/archiso_shutdown
@@ -0,0 +1,23 @@
+run_hook ()
+{
+ msg -n ":: Creating shutdown ramfs..."
+
+ for _dir in bin lib sbin usr/bin usr/lib usr/sbin; do
+ mkdir -p /run/initramfs/${_dir}
+ done
+ cp /bin/busybox /run/initramfs/bin/
+ cp /lib/ld-* /run/initramfs/lib/
+ cp /lib/lib* /run/initramfs/lib/
+ cp /usr/lib/lib* /run/initramfs/usr/lib/
+ cp /bin/mount /run/initramfs/bin/
+ cp /sbin/dmsetup /run/initramfs/sbin/
+ cp /sbin/losetup /run/initramfs/sbin/
+ if [[ -x /bin/nbd-client ]]; then
+ cp /bin/nbd-client /run/initramfs/bin/
+ fi
+
+ chroot /run/initramfs /bin/busybox --install
+ cp /shutdown /run/initramfs/
+
+ msg "done."
+}
diff --git a/archiso/install/archiso b/archiso/install/archiso
index 514c011..c36c001 100644
--- a/archiso/install/archiso
+++ b/archiso/install/archiso
@@ -1,30 +1,19 @@
-build ()
-{
- MODULES="cdrom ide-cd_mod ide-core ide-generic loop dm-mod dm-snapshot squashfs isofs $(all_modules '/kernel/fs' | grep -v "nls")"
- MODULES="${MODULES} $(checked_modules "/usb/host" | grep -ve "_cs" -e "sl811_hcd" -e "isp116x_hcd")"
- MODULES="${MODULES} usb_storage sd_mod sr_mod"
- MODULES="${MODULES} virtio_pci virtio_blk"
- MODULES=$(echo ${MODULES}) #trim whitespace
+#!/bin/bash
- BINARIES=""
- FILES=""
-
- add_dir /cowspace
- add_dir /copytoram
- add_dir /bootmnt
-
- add_binary /lib/udev/cdrom_id
- add_binary /sbin/blockdev
- add_binary /sbin/lvm
- add_binary /sbin/dmsetup
+build() {
+ MODULES="cdrom loop dm-snapshot"
+ SCRIPT="archiso"
- add_file /lib/udev/rules.d/60-cdrom_id.rules
- add_file /lib/udev/rules.d/10-dm.rules
- add_file /lib/udev/rules.d/13-dm-disk.rules
- add_file /lib/udev/rules.d/95-dm-notify.rules
- add_file /lib/udev/rules.d/11-dm-lvm.rules
+ add_binary /usr/lib/udev/cdrom_id
+ add_binary blockdev
+ add_binary dmsetup
+ add_binary losetup
+ add_binary mountpoint
- SCRIPT="archiso"
+ add_file /usr/lib/udev/rules.d/60-cdrom_id.rules
+ add_file /usr/lib/udev/rules.d/10-dm.rules
+ add_file /usr/lib/udev/rules.d/95-dm-notify.rules
+ add_file /usr/lib/initcpio/udev/11-dm-initramfs.rules /usr/lib/udev/rules.d/11-dm-initramfs.rules
}
-# vim:ft=sh:ts=4:sw=4:et:
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/archiso/install/archiso_kms b/archiso/install/archiso_kms
new file mode 100644
index 0000000..6566049
--- /dev/null
+++ b/archiso/install/archiso_kms
@@ -0,0 +1,14 @@
+#!/bin/bash
+
+build() {
+ MODULES="radeon nouveau i915 via-agp sis-agp intel-agp"
+ if [[ $(uname -m) == i686 ]]; then
+ MODULES+=" amd64-agp ati-agp sworks-agp ali-agp amd-k7-agp nvidia-agp efficeon-agp"
+ fi
+}
+
+help() {
+ cat << HELPEOF
+Adds all common KMS drivers to the initramfs image.
+HELPEOF
+}
diff --git a/archiso/install/archiso_loop_mnt b/archiso/install/archiso_loop_mnt
index 2c8d6f2..4141043 100644
--- a/archiso/install/archiso_loop_mnt
+++ b/archiso/install/archiso_loop_mnt
@@ -1,18 +1,13 @@
-# vim: set ft=sh:
+#!/bin/bash
-build ()
-{
- MODULES=""
-
- BINARIES=""
- FILES=""
- add_dir /img_dev
+build() {
SCRIPT="archiso_loop_mnt"
}
-help ()
-{
+help() {
cat<<HELPEOF
This hook loads the necessary modules for boot via loop device.
HELPEOF
}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/archiso/install/archiso_pxe_common b/archiso/install/archiso_pxe_common
new file mode 100644
index 0000000..b37e5a1
--- /dev/null
+++ b/archiso/install/archiso_pxe_common
@@ -0,0 +1,30 @@
+#!/bin/bash
+
+build() {
+ MODULES="${MODULES} $(comm -2 -3 <(checked_modules "/drivers/net/" | sort) \
+ <(find $MODULEDIR/kernel/drivers/net/{irda,phy,wimax,wireless} \
+ -name '*.ko*' \
+ -exec bash -c 'printf "%s\n" "${@%%.ko*}" | sed "s@.*/@@;s@-@_@" | sort' _ {} +) \
+ | grep -v -e 'ppp_' -e 'plip' -e 'pppoe')"
+ SCRIPT="archiso_pxe_common"
+
+
+ add_binary /lib/initcpio/ipconfig /bin/ipconfig
+
+ # Add hosts support files+dns
+ add_symlink /lib/libnss_files.so.2 $(readlink /lib/libnss_files.so.2)
+ add_binary $(readlink -f /lib/libnss_files.so.2)
+ add_symlink /lib/libnss_dns.so.2 $(readlink /lib/libnss_dns.so.2)
+ add_binary $(readlink -f /lib/libnss_dns.so.2)
+
+ add_dir /etc
+ echo "hosts: files dns" > $BUILDROOT/etc/nsswitch.conf
+}
+
+help() {
+cat<<HELPEOF
+ This hook loads the necessary modules for boot via PXE.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/archiso/install/archiso_pxe_http b/archiso/install/archiso_pxe_http
new file mode 100644
index 0000000..9e2ff65
--- /dev/null
+++ b/archiso/install/archiso_pxe_http
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+build() {
+ SCRIPT="archiso_pxe_http"
+
+ add_binary curl
+}
+
+help() {
+cat<<HELPEOF
+ This hook loads the necessary modules for boot via PXE and HTTP.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/archiso/install/archiso_pxe_nbd b/archiso/install/archiso_pxe_nbd
index c8ba1a4..1ee3910 100644
--- a/archiso/install/archiso_pxe_nbd
+++ b/archiso/install/archiso_pxe_nbd
@@ -1,24 +1,18 @@
-# vim: set ft=sh:
+#!/bin/bash
-build ()
-{
+build() {
MODULES="nbd"
- MODULES="${MODULES} $(comm -2 -3 <(checked_modules "/drivers/net/" | sort) \
- <(find $MODULEDIR/kernel/drivers/net/{irda,phy,wimax,wireless} \
- -name '*.ko*' \
- -exec bash -c 'printf "%s\n" "${@%%.ko*}" | sed "s@.*/@@;s@-@_@" | sort' _ {} +) \
- | grep -v -e 'ppp_' -e 'plip' -e 'pppoe')"
- BINARIES=""
- FILES=""
SCRIPT="archiso_pxe_nbd"
- add_binary "/usr/sbin/nbd-client" "/bin/nbd-client"
- add_binary "/lib/initcpio/ipconfig" "/bin/ipconfig"
+ add_binary nbd-client
+
+ add_file /usr/lib/initcpio/archiso_pxe_nbd /archiso_pxe_nbd
}
-help ()
-{
+help() {
cat<<HELPEOF
This hook loads the necessary modules for boot via PXE and NBD.
HELPEOF
}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/archiso/install/archiso_pxe_nfs b/archiso/install/archiso_pxe_nfs
new file mode 100644
index 0000000..f7b6f5d
--- /dev/null
+++ b/archiso/install/archiso_pxe_nfs
@@ -0,0 +1,16 @@
+#!/bin/bash
+
+build() {
+ MODULES="nfs"
+ SCRIPT="archiso_pxe_nfs"
+
+ add_binary /lib/initcpio/nfsmount /bin/nfsmount
+}
+
+help() {
+ cat <<HELPEOF
+ This hook loads the necessary modules for boot via PXE and NFS.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/archiso/install/archiso_shutdown b/archiso/install/archiso_shutdown
new file mode 100644
index 0000000..87b8297
--- /dev/null
+++ b/archiso/install/archiso_shutdown
@@ -0,0 +1,18 @@
+#!/bin/bash
+
+build() {
+ SCRIPT="archiso_shutdown"
+
+ add_file /usr/lib/initcpio/archiso_shutdown /shutdown
+}
+
+help() {
+ cat <<HELPEOF
+This hook will create a shutdown initramfs in /run/initramfs
+that we can pivot to on shutdown in order to unmount / and
+and others mount points, dm-snapshot devices and loopback devices.
+Mostly usefull for dm-snapshot persistent.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/archiso/mkarchiso b/archiso/mkarchiso
index 1c3242d..6f02131 100755
--- a/archiso/mkarchiso
+++ b/archiso/mkarchiso
@@ -2,15 +2,20 @@
set -e -u
+export LANG=C
+
app_name=${0##*/}
arch=$(uname -m)
pkg_list=""
+run_cmd=""
quiet="y"
pacman_conf="/etc/pacman.conf"
export iso_label="PARABOLA_$(date +%Y%m)"
iso_publisher="Parabola GNU/Linux-libre <https://parabolagnulinux.org>"
iso_application="Parabola Live/Rescue CD"
install_dir="libre"
+work_dir="work"
+out_dir="out"
# Show an INFO message
# $1: message string
@@ -42,6 +47,44 @@ _show_space_usage () {
_msg_info "Total: ${_total} MiB (100%) | Used: ${_used} MiB (${_pct_u}) | Avail: ${_avail} MiB ($((100 - ${_pct_u%\%}))%)"
}
+_chroot_mount () {
+ mount -t devtmpfs dev "${work_dir}/root-image/dev"
+ mount -t devpts devpts "${work_dir}/root-image/dev/pts"
+ mount -t tmpfs devshm "${work_dir}/root-image/dev/shm"
+ mount -t proc proc "${work_dir}/root-image/proc"
+ mount -t tmpfs run "${work_dir}/root-image/run"
+ mount -t sysfs sys "${work_dir}/root-image/sys"
+ mount -t tmpfs tmp "${work_dir}/root-image/tmp"
+
+ trap '_chroot_umount' EXIT HUP INT TERM
+}
+
+_chroot_umount () {
+ umount "${work_dir}/root-image/tmp"
+ umount "${work_dir}/root-image/sys"
+ umount "${work_dir}/root-image/run"
+ umount "${work_dir}/root-image/proc"
+ umount "${work_dir}/root-image/dev/shm"
+ umount "${work_dir}/root-image/dev/pts"
+ umount "${work_dir}/root-image/dev"
+
+ trap - EXIT HUP INT TERM
+}
+
+_chroot_init() {
+ if [[ ! -d ${work_dir}/root-image/var/cache/pacman ]]; then
+ mkdir -p ${work_dir}/root-image/{dev,proc,run,sys,tmp,var/lib/pacman}
+ _pacman "base"
+ _pacman "syslinux"
+ fi
+}
+
+_chroot_run() {
+ _chroot_mount
+ eval chroot ${work_dir}/root-image "${run_cmd}"
+ _chroot_umount
+}
+
# Mount a filesystem (trap signals in case of error for unmounting it
# $1: source image
# $2: mount-point
@@ -97,30 +140,44 @@ _usage ()
echo "usage ${app_name} [options] command <command options>"
echo " general options:"
echo " -p PACKAGE(S) Package(s) to install, can be used multiple times"
- echo " -C <file> Config file for pacman. Default ${pacman_conf}"
+ echo " -r <command> Run <command> inside root-image"
+ echo " -C <file> Config file for pacman."
+ echo " Default: '${pacman_conf}'"
echo " -L <label> Set a label for the disk"
+ echo " Default: '${iso_label}'"
echo " -P <publisher> Set a publisher for the disk"
+ echo " Default: '${iso_publisher}'"
echo " -A <application> Set an application name for the disk"
+ echo " Default: '${iso_application}'"
echo " -D <install_dir> Set an install_dir. All files will by located here."
- echo " Default ${install_dir}"
+ echo " Default: '${install_dir}'"
echo " NOTE: Max 8 characters, use only [a-z0-9]"
+ echo " -w <work_dir> Set the working directory"
+ echo " Default: '${work_dir}'"
+ echo " -o <out_dir> Set the output directory"
+ echo " Default: '${out_dir}'"
echo " -v Enable verbose output"
echo " -h This message"
echo " commands:"
- echo " create <dir>"
- echo " create a base directory layout to work with"
- echo " includes all specified packages"
- echo " prepare <dir>"
+ echo " init"
+ echo " Make base layout and install base group"
+ echo " install"
+ echo " Install all specified packages (-p)"
+ echo " run"
+ echo " run command specified by -r"
+ echo " prepare"
echo " build all images"
- echo " checksum <dir>"
+ echo " checksum"
echo " make a checksum.md5 for self-test"
- echo " iso <dir> <image name>"
+ echo " pkglist"
+ echo " make a pkglist.txt of packages installed on root-image"
+ echo " iso <image name>"
echo " build an iso image from the working dir"
exit ${1}
}
# Shows configuration according to command mode.
-# $1: create | prepare | iso
+# $1: init | install | run | prepare | checksum | iso
_show_config () {
local _mode="$1"
echo
@@ -130,14 +187,22 @@ _show_config () {
_msg_info " Working directory: ${work_dir}"
_msg_info " Installation directory: ${install_dir}"
case "${_mode}" in
- create)
+ init)
+ _msg_info " Pacman config file: ${pacman_conf}"
+ ;;
+ install)
_msg_info " Pacman config file: ${pacman_conf}"
_msg_info " Packages: ${pkg_list}"
;;
+ run)
+ _msg_info " Run command: ${run_cmd}"
+ ;;
prepare)
;;
checksum)
;;
+ pkglist)
+ ;;
iso)
_msg_info " Image name: ${img_name}"
_msg_info " Disk label: ${iso_label}"
@@ -153,20 +218,23 @@ _pacman ()
{
_msg_info "Installing packages to '${work_dir}/root-image/'..."
+ _chroot_mount
+
if [[ "${quiet}" = "y" ]]; then
- mkarchroot -n -C "${pacman_conf}" -f "${work_dir}/root-image" $* &> /dev/null
+ pacman -Sy -r "${work_dir}/root-image" --config "${pacman_conf}" --needed --noconfirm $* &> /dev/null
else
- mkarchroot -n -C "${pacman_conf}" -f "${work_dir}/root-image" $*
+ pacman -Sy -r "${work_dir}/root-image" --config "${pacman_conf}" --needed --noconfirm $*
fi
- # Cleanup
- find "${work_dir}" -name "*.pacnew" -name "*.pacsave" -name "*.pacorig" -delete
+ _chroot_umount
+
_msg_info "Packages installed successfully!"
}
# Cleanup root-image
_cleanup () {
_msg_info "Cleaning up what we can on root-image"
+
# remove the initcpio images that were generated for the host system
if [[ -d "${work_dir}/root-image/boot" ]]; then
find "${work_dir}/root-image/boot" -name '*.img' -delete
@@ -195,9 +263,11 @@ _cleanup () {
if [[ -d "${work_dir}/root-image/tmp" ]]; then
find "${work_dir}/root-image/tmp" -mindepth 1 -delete
fi
- # Delete etc/mtab if not is a symlink.
+ # Delete package pacman related files.
+ find "${work_dir}" -name "*.pacnew" -name "*.pacsave" -name "*.pacorig" -delete
+ # Create etc/mtab if not is a symlink.
if [[ ! -L "${work_dir}/root-image/etc/mtab" ]]; then
- rm -f "${work_dir}/root-image/etc/mtab"
+ ln -sf "/proc/self/mounts" "${work_dir}/root-image/etc/mtab"
fi
}
@@ -217,9 +287,9 @@ _mksfs () {
_msg_info "Creating SquashFS image for '${work_dir}/${_src}', This may take some time..."
local _seconds=${SECONDS}
if [[ "${quiet}" = "y" ]]; then
- mksquashfs "${work_dir}/${_src}" "${_sfs_img}" -noappend -comp "${_sfs_comp}" &> /dev/null
+ mksquashfs "${work_dir}/${_src}" "${_sfs_img}" -noappend -comp "${_sfs_comp}" -no-progress &> /dev/null
else
- mksquashfs "${work_dir}/${_src}" "${_sfs_img}" -noappend -comp "${_sfs_comp}"
+ mksquashfs "${work_dir}/${_src}" "${_sfs_img}" -noappend -comp "${_sfs_comp}" -no-progress
fi
_seconds=$((SECONDS - _seconds))
printf "[mkarchiso] INFO: Image creation done in %02d:%02d minutes\n" $((_seconds / 60)) $((_seconds % 60))
@@ -293,40 +363,79 @@ _mkfs () {
command_checksum () {
_show_config checksum
- _msg_info "Creating checksum file for self-test"
- cd "${work_dir}/iso/${install_dir}"
- find -type f ! -name checksum.md5 -print0 | xargs -0 md5sum > checksum.md5
- cd ${OLDPWD}
- _msg_info "Done!"
+ local _chk_arch
+
+ for _chk_arch in i686 x86_64; do
+ if _is_directory_changed "${work_dir}/iso/${install_dir}" "${work_dir}/iso/${install_dir}/checksum.${_chk_arch}.md5"; then
+ _msg_info "Creating checksum file for self-test (${_chk_arch})"
+ cd "${work_dir}/iso/${install_dir}"
+ if [[ -d "${_chk_arch}" ]]; then
+ md5sum aitab > checksum.${_chk_arch}.md5
+ find ${_chk_arch} -type f -print0 | xargs -0 md5sum >> checksum.${_chk_arch}.md5
+ if [[ -d "any" ]]; then
+ find any -type f -print0 | xargs -0 md5sum >> checksum.${_chk_arch}.md5
+ fi
+ fi
+ cd ${OLDPWD}
+ _msg_info "Done!"
+ fi
+ done
+}
+
+command_pkglist () {
+ _show_config pkglist
+
+ if _is_directory_changed "${work_dir}/root-image/var/lib/pacman/local" "${work_dir}/iso/${install_dir}/pkglist.${arch}.txt"; then
+ _msg_info "Creating a list of installed packages on live-enviroment"
+ pacman -Sl -r "${work_dir}/root-image" --config "${pacman_conf}" | \
+ awk '/\[installed\]$/ {print $1 "/" $2 "-" $3}' > \
+ "${work_dir}/iso/${install_dir}/pkglist.${arch}.txt"
+ _msg_info "Done!"
+ fi
+
}
# Create an ISO9660 filesystem from "iso" directory.
command_iso () {
+ local _iso_efi_boot_args=""
+
if [[ ! -f "${work_dir}/iso/isolinux/isolinux.bin" ]]; then
_msg_error "The file '${work_dir}/iso/isolinux/isolinux.bin' does not exist." 1
fi
+ if [[ ! -f "${work_dir}/iso/isolinux/isohdpfx.bin" ]]; then
+ _msg_error "The file '${work_dir}/iso/isolinux/isohdpfx.bin' does not exist." 1
+ fi
- _show_config iso
+ # If exists, add an EFI "El Torito" boot image (FAT filesystem) to ISO-9660 image.
+ if [[ -f "${work_dir}/iso/EFI/archiso/efiboot.img" ]]; then
+ _iso_efi_boot_args="--efi-boot EFI/archiso/efiboot.img"
+ fi
- _is_directory_changed "${work_dir}/iso" "${img_name}"
+ _show_config iso
- _msg_info "Creating ISO image..."
- local _qflag=""
- if [[ ${quiet} == "y" ]]; then
- _qflag="-quiet"
+ if _is_directory_changed "${work_dir}/iso" "${out_dir}/${img_name}"; then
+ mkdir -p ${out_dir}
+ _msg_info "Creating ISO image..."
+ local _qflag=""
+ if [[ ${quiet} == "y" ]]; then
+ _qflag="-quiet"
+ fi
+ xorriso -as mkisofs ${_qflag} \
+ -iso-level 3 \
+ -full-iso9660-filenames \
+ -volid "${iso_label}" \
+ -appid "${iso_application}" \
+ -publisher "${iso_publisher}" \
+ -preparer "prepared by mkarchiso" \
+ -eltorito-boot isolinux/isolinux.bin \
+ -eltorito-catalog isolinux/boot.cat \
+ -no-emul-boot -boot-load-size 4 -boot-info-table \
+ ${_iso_efi_boot_args} \
+ -isohybrid-mbr ${work_dir}/iso/isolinux/isohdpfx.bin \
+ -output "${out_dir}/${img_name}" \
+ "${work_dir}/iso/"
+ _msg_info "Done! | $(ls -sh ${out_dir}/${img_name})"
fi
- mkisofs ${_qflag} -r -l \
- -b isolinux/isolinux.bin -c isolinux/boot.cat \
- -uid 0 -gid 0 \
- -udf -allow-limited-size -iso-level 3 \
- -input-charset utf-8 -p "prepared by mkarchiso" \
- -no-emul-boot -boot-load-size 4 -boot-info-table \
- -publisher "${iso_publisher}" \
- -A "${iso_application}" \
- -V "${iso_label}" \
- -o "${img_name}" "${work_dir}/iso/"
- isohybrid "${img_name}"
- _msg_info "Done! | $(ls -sh ${img_name})"
}
# Parse aitab and create each filesystem specified on that, and push it in "iso" directory.
@@ -342,25 +451,15 @@ command_prepare () {
if [[ ${_aitab_img} =~ ^# ]]; then
continue
fi
- if [[ ${_aitab_sfs_comp} == "none" && ${_aitab_fs_type} == "none" ]]; then
- _msg_error "In aitab, both fields 'sfs_comp' and 'fs_type' are set to none for '${_aitab_img}' image" 1
- fi
local _src="${work_dir}/${_aitab_img}"
local _dst="${work_dir}/iso/${install_dir}/${_aitab_arch}"
mkdir -p "${_dst}"
if [[ ${_aitab_fs_type} != "none" ]]; then
- if [[ ${_aitab_sfs_comp} != "none" ]]; then
- if _is_directory_changed "${_src}" "${_dst}/${_aitab_img}.fs.sfs"; then
- _mkfs ${_aitab_img} ${_aitab_fs_type} ${_aitab_fs_size}
- _mksfs ${_aitab_img}.fs ${_aitab_sfs_comp}
- mv "${_src}.fs.sfs" "${_dst}"
- rm "${_src}.fs"
- fi
- else
- if _is_directory_changed "${_src}" "${_dst}/${_aitab_img}.fs"; then
- _mkfs ${_aitab_img} ${_aitab_fs_type} ${_aitab_fs_size}
- mv "${work_dir}/${_aitab_img}.fs" "${_dst}"
- fi
+ if _is_directory_changed "${_src}" "${_dst}/${_aitab_img}.fs.sfs"; then
+ _mkfs ${_aitab_img} ${_aitab_fs_type} ${_aitab_fs_size}
+ _mksfs ${_aitab_img}.fs ${_aitab_sfs_comp}
+ mv "${_src}.fs.sfs" "${_dst}"
+ rm "${_src}.fs"
fi
else
if _is_directory_changed "${_src}" "${_dst}/${_aitab_img}.sfs"; then
@@ -373,7 +472,7 @@ command_prepare () {
# Install packages on root-image.
# A basic check to avoid double execution/reinstallation is done via hashing package names.
-command_create () {
+command_install () {
if [[ ! -f "${pacman_conf}" ]]; then
_msg_error "Pacman config file '${pacman_conf}' does not exist" 1
fi
@@ -386,32 +485,43 @@ command_create () {
_usage 1
fi
- _show_config create
+ _show_config install
local _pkg_list_hash
_pkg_list_hash=$(echo ${pkg_list} | sort -u | md5sum | cut -c1-32)
- if [[ -f "${work_dir}/create.${_pkg_list_hash}" ]]; then
+ if [[ -f "${work_dir}/install.${_pkg_list_hash}" ]]; then
_msg_info "These packages are already installed, skipping."
else
- mkdir -p "${work_dir}/root-image/"
_pacman "${pkg_list}"
- : > "${work_dir}/create.${_pkg_list_hash}"
+ : > "${work_dir}/install.${_pkg_list_hash}"
fi
}
+command_init() {
+ _show_config init
+ _chroot_init
+}
+
+command_run() {
+ _show_config run
+ _chroot_run
+}
if [[ ${EUID} -ne 0 ]]; then
_msg_error "This script must be run as root." 1
fi
-while getopts 'p:C:L:P:A:D:fvh' arg; do
+while getopts 'p:r:C:L:P:A:D:w:o:vh' arg; do
case "${arg}" in
p) pkg_list="${pkg_list} ${OPTARG}" ;;
+ r) run_cmd="${OPTARG}" ;;
C) pacman_conf="${OPTARG}" ;;
L) iso_label="${OPTARG}" ;;
P) iso_publisher="${OPTARG}" ;;
A) iso_application="${OPTARG}" ;;
D) install_dir="${OPTARG}" ;;
+ w) work_dir="${OPTARG}" ;;
+ o) out_dir="${OPTARG}" ;;
v) quiet="n" ;;
h|?) _usage 0 ;;
*)
@@ -429,15 +539,15 @@ if [[ $# -lt 1 ]]; then
fi
command_name="${1}"
-if [[ $# -lt 2 ]]; then
- _msg_error "No working directory specified" 0
- _usage 1
-fi
-work_dir="${2}"
-
case "${command_name}" in
- create)
- command_create
+ init)
+ command_init
+ ;;
+ install)
+ command_install
+ ;;
+ run)
+ command_run
;;
prepare)
command_prepare
@@ -445,12 +555,15 @@ case "${command_name}" in
checksum)
command_checksum
;;
+ pkglist)
+ command_pkglist
+ ;;
iso)
- if [[ $# -lt 3 ]]; then
+ if [[ $# -lt 2 ]]; then
_msg_error "No image specified" 0
_usage 1
fi
- img_name="${3}"
+ img_name="${2}"
command_iso
;;
*)
diff --git a/archiso/testiso b/archiso/testiso
index 75bedc9..71e85e1 100755
--- a/archiso/testiso
+++ b/archiso/testiso
@@ -1,6 +1,6 @@
#!/bin/bash
-if [ $# -eq 0 ]; then
+if [[ $# -eq 0 ]]; then
echo "usage: testiso <isofile> [id|ic|sd|sc|vd|vc]"
echo
echo "id boot .iso as IDE disk"
@@ -8,7 +8,7 @@ if [ $# -eq 0 ]; then
echo "sd boot .iso as SCSI disk"
echo "sc boot .iso as SCSI cd-rom"
echo "vd boot .iso as virtio disk"
- echo "vc boot .iso as virtio cd-rom"
+# echo "vc boot .iso as virtio cd-rom"
exit 1
fi
@@ -18,9 +18,9 @@ case "${2}" in
sd) IF="scsi"; MEDIA="disk";;
sc) IF="scsi"; MEDIA="cdrom";;
vd) IF="virtio"; MEDIA="disk";;
- vc) IF="virtio"; MEDIA="cdrom";;
+# vc) IF="virtio"; MEDIA="cdrom";;
*) IF="scsi"; MEDIA="cdrom";;
esac
-echo qemu -m 256 -drive file=${1},if=${IF},media=${MEDIA},boot=on
-qemu -m 256 -drive file=${1},if=${IF},media=${MEDIA},boot=on
+echo qemu-system-x86_64 -m 256 -drive file=${1},if=${IF},media=${MEDIA},boot=on
+qemu-system-x86_64 -m 256 -drive file=${1},if=${IF},media=${MEDIA},boot=on